
static char rcsid[] = "@(#)$Id: returnadd.c,v 1.2 1998/10/20 19:58:17 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.2 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 ******************************************************************************
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

/** This set of routines is used to generate real return addresses
    and also return addresses suitable for inclusion in a users
    alias files (ie optimized based on the pathalias database).

**/

#include "headers.h"
#include "s_elm.h"

#include <errno.h>
#include <sys/stat.h>

#include "me.h"

char *shift_lower();

extern int errno;

char *error_description();


static void kludge P_((char *buffer, int size));
static void kludge(buffer, size) 
     char * buffer;
     int size;
{
  if (qchloc(buffer, '@') < 0
      && qchloc(buffer, '%') < 0
      && qchloc(buffer, '!') < 9)
    {
      strfcat(buffer,"@", size);
      strfcat(buffer,hostfullname, size);
    }
}

int get_return(buffer, msgnum, size)
     char *buffer;
     int msgnum;
     int size;
{
	/** reads msgnum message again, building up the full return 
	    address including all machines that might have forwarded 
	    the message.  Returns whether it is using the To line **/

	int using_to = FALSE, err;
	struct addr_item *ptr;

	/* now initialize all the char buffers [thanks Keith!] */

	/** get to the first line of the message desired **/

	if(msgnum < 0 || msgnum >= message_count || message_count < 1) {
	  dprint(1, (debugfile,
		"Error: %d not a valid message number message_count = %d (%s)",
		msgnum, message_count, "get_return"));
	  lib_error(CATGETS(elm_msg_cat, ElmSet, ElmNotAValidMessageNum,
			    "%d not a valid message number!"), 
		    msgnum);
	  return(using_to);
	}

	/* reply-to is now handle in handle_reply_to */

	buffer[0] = '\0';
	for (ptr = headers[msgnum]->from; 
	     ptr && ptr -> addr && ptr->fullname; 
	     ptr++) {
	  char buffer1[STRING];
	  
	  strfcpy(buffer1,ptr->addr, sizeof buffer1);
	  /*
	   * KLUDGE ALERT - DANGER WILL ROBINSON
	   * We can't just leave a bare login name as the return address,
	   * or it will be alias-expanded.
	   * So we qualify it with the current host name (and, maybe, domain).
	   * Sigh.
	   */

	  kludge(buffer1,sizeof buffer1);
	  
	  if (buffer[0] != '\0')
	    strfcat(buffer,", ", size);
	  strfcat(buffer,buffer1, size);
	  
	  if (ptr->fullname[0] != '\0') {
#ifdef MIME
	    if (!allow_no_hdrencoding) {
	      /* from is not longer mime encoded */
	      
	      char temp[LONG_STRING];
	      rfc1522_encode_text(temp,sizeof temp,ptr->fullname,
				  HDR_COMMENT);
	      elm_sfprintf(buffer + strlen(buffer), size - strlen(buffer),
			   FRM(" (%s)"), 
			   temp);	    
	    } else
#endif 
	      elm_sfprintf(buffer + strlen(buffer), size - strlen(buffer),
			   FRM(" (%s)"), 
			   ptr->fullname);
	  }
	}
	
	if (buffer[0] == '\0') {
	  strfcpy(buffer,headers[msgnum]->env_from,size);
	  kludge(buffer,size);

	}

	return(using_to);
}
